Subject: Re: [I2nsf] Comments/questions about draft-ietf-i2nsf-problem-and-use-cases

From: Daniel Migault <[email-masked]>
Date: Wed, 2 Nov 2016 06:00:29 -0400

Hi,

I read the doument and here are my comments.

Yours,
Daniel

3.  Problem Space
3.1.  Challenges Facing Security Service Providers
3.1.1.  Diverse Types of Security Functions

   Internal Data and Content Protection:   Examples of this function are
      encryption, authorization, and public/private key management for
      internal database.

   Given the diversity of security functions, the contexts in which
   these functions can be deployed, and the constant evolution of these

Hares, et al.             Expires April 8, 2017                 [Page 5]

Internet-Draft           I2NSF Problem/Use Case             October 2016

   functions, standardizing all aspects of security functions is
   challenging, and most probably not feasible.  Fortunately, it is not
   necessary to standardize all aspects.  For example, from an I2NSF
   perspective, there is no need to standardize on how firewall filters
   are created or applied.

MGLT: Maybe that woudl also be helpful to specify what I2NSF needs to
define. More specifically, I2NSF should define a high level description of
the interface that is implementation and vendor independent. What is not so
clear to me is, in the casse of the firewall what kind of interaction are
in the scope of I2NSF. From reading the gap analysis document it seems to
me that provisionning and configuring the firewall with rules is not in the
scope of I2NSF yet. Instead the I2NSF is interested in capabilities of the
fucntions. Typically the support of IPv6 could be a capability for the
firewall.

3.1.2.  Diverse Interfaces to Control and Monitor NSFs

   A challenge for monitoring is that an NSF cannot monitor what it
   cannot view.  Therefore, enabling a security function (e.g., firewall
   [I-D.ietf-opsawg-firewalls]) does not mean that a network is
   protected.  As such, it is necessary to have a mechanism to monitor
   and provide execution status of NSFs to security and compliance
   management tools.  There exist various network security monitoring
   vendor-specific interfaces for forensics and troubleshooting.

MGLT: "what it cannot view" is not clear to me. It might be helpful to be
more positive and define what it can monitor. That said, what was confusing
for me is whether viewing is achieved by configuring the appropriated
firewall rules or because ther is a need to provide feedbacks or status on
the firewall activity.

3.1.3.  More Distributed NSFs and vNSFs

   The security functions which are invoked to enforce a security policy
   can be located in different equipment and network locations.

   The European Telecommunications Standards Institute (ETSI) Network
   Function Virtualization (NFV) initiative creates new management
   challenges for security policies to be enforced by distributed,
   virtual, and network security functions (vNSF).

   A vNSF has higher risk of failure, migrating, and state changes as
   their hosting VMs are being created, moved, or decommissioned.

 MGLT: Given that statement I believe it would be helpful to understand how
I2NSF is related to that challenge and how it expects to address that
challenge. I also believe that such clarification could be provide for
other issues.

3.1.6.  Lack of Characterization of NSFs and Capability Exchange

   Today, there is no standard method for vendors to describe the
   capabilities of their security functions.  Without a common technical
   framework to describe the capabilities of security functions, service
   providers cannot automate the process of selecting NSFs by different
   vendors to accommodate customer's requirements.

MGLT: I like the current text of this section. It is much clearer than in
the previous version. ;-) and clearly state how I2NSF is expected to
address this issue.

Hares, et al.             Expires April 8, 2017                 [Page 7]

Internet-Draft           I2NSF Problem/Use Case             October 2016

3.1.7.  Lack of Mechanism for NSFs to Utilize External Profiles

   Many security functions depend on signature files or profiles to
   perform (e.g., IPS/IDS signatures, DOTS filters).  Different policies
   might need different signatures or profiles.  Today, the construction
   and use of black list databases can be a win-win strategy for all
   parties involved.  There might be Open Source-provided signature/
   profiles (e.g., by Snort or others) in the future.

MGLT: I am not sure there is a consensus on what DOTS fileters are. I
believe it would hep th ereader to clarify or illustrate what the profile
is. I understand profile as the correlation of observations.

   There is a need to have a standard envelop (i.e., the format) to
   allow NSFs to use external profiles.

MGLT: Would'nt it a YANG models that makes possible the definition of
profiles. A profile would be in that case the speciifc instantiation of a
YANG model (the set of values associated to the model). These models will
be used by I2NSF to derive the actions from the Customer Interfcae which is
excpected to use a more abstract description and designate the profile by a
common name.

3.1.9.  Lack of Mechanism for Dynamic Key Distribution to NSFs

   There is a need for a controller to distribute various keys to
   distributed NSFs.  To distribute various keys, the keys must be
   created and managed.  While there are many key management methods and
   key derivation functions (KDF), there is a lack of standard interface
   to provision and manage keys.

   The keys may be used for message authentication and integrity in
   order to protect data flows.  In addition, keys may be used to secure

Hares, et al.             Expires April 8, 2017                 [Page 8]

Internet-Draft           I2NSF Problem/Use Case             October 2016

   the protocol and messages in the core routing infrastructure
   ([RFC4948])

   As of now there is not much focus on an abstraction for keying
   information that describes the interface between protocols,
   operators, and automated key management.

   The ability to utilize keys when routing protocols send or receive
   messages will be enhanced by having an abstract key table maintained
   by a security service.  Conceptually, there must be an interface
   defined for routing/signaling protocols to make requests for
   automated key management when it is being used, to notify the
   protocols when keys become available in the key table.

   An abstract key service will work under the following conditions:

   1.  I2NSF needs to design the key table abstraction, the interface
       between key management protocols and routing/other protocols, and
       possibly security protocols at other layers.

MGLT: It is not clear to me what "key table abstraction" is. I have little
knowledge in routing protocols, but I believe this section is really
routing oriented, and I hardly see any application for TLS/IPsec... other
then key provisionning. Am I correct ?

3.4.  Lack of Standard Interface to Inject Feedback to NSF

   Today, many security functions, such as IPS, IDS, DDoS and Antivirus,
   depend heavily on the associated profiles.  They can perform more
   effective protection if they have the up-to-date profiles.  As more
   sophisticated threats arise, enterprises, vendors, and service
   providers have to rely on each other to achieve optimal protection.
   Cyper Threat Alliance (CA, http://cyberthreatalliance.org/) is one of
   those initiatives that aim at combining efforts conducted by multiple
   organizations.

Hares, et al.             Expires April 8, 2017                [Page 12]

Internet-Draft           I2NSF Problem/Use Case             October 2016

   Today there is no standard interface to exchange security profiles
   between organizations.

MGLT: From the text it looks that there is a need to define a catalogue of
profile. I hardly believe that everyone would converge with a single set of
profiles. Instead I believe that each domain will define its own profile
and need to provide them to another domain. Am I correct ?

4.  Use Cases

4.3.  Cloud Data Center Scenario

   In a data center, network security mechanisms such as firewalls may
   need to be dynamically added or removed for a number of reasons.
   These changes may be explicitly requested by the user, or triggered
   by a pre-agreed upon Service Level Agreement (SLA) between the user
   and the provider of the service.  For example, the service provider
   may be required to add more firewall capacity within a set timeframe
   whenever the bandwidth utilization hits a certain threshold for a
   specified period.  This capacity expansion could result in adding new
   instances of firewalls on existing machines or provisioning a
   completely new firewall instance in a different machine.

   The on-demand, dynamic nature of security service delivery
   essentially encourages that the network security "devices" be in
   software or virtual form factors, rather than in a physical appliance
   form.  This requirement is a provider-side concern.  Users of the
   firewall service are agnostic (as they should) as to whether or not
   the firewall service is run on a VM or any other form factor.
   Indeed, they may not even be aware that their traffic traverses
   firewalls.

   Furthermore, new firewall instances need to be placed in the "right
   zone" (domain).  The issue applies not only to multi-tenant
   environments where getting the tenant in the right domain is of
   paramount importance, but also in environments owned and operated by
   a single organization with its own service segregation policies.  For
   example, an enterprise may mandate that firewalls serving Internet
   traffic and Business-to-Business (B2B) traffic be separated.  Another
   example is that IPS/IDS services for investment banking and non-
   banking traffic may be separated for regulatory reasons.

MGLT: Maybe it woudl be nice to position I2NSF toward this use case as in
the prvious sub-sections.

4.3.2.  Firewall Policy Deployment Automation

   Firewall rule setting is often a time consuming, complex and error-
   prone process even within a single organization/enterprise framework.
   It becomes far more complex in provider-owned cloud networks that
   serve myriads of customers.

   Firewall rules today are highly tied with ports and addresses that
   identify traffic.  This makes it very difficult for clients of cloud
   data centers to construct rules for their own traffic as the clients
   only see the virtual networks and the virtual addresses.  The
   customer-visible virtual networks and addresses may be different from
   the actual packets traversing the FWs.

   Even though most vendors support similar firewall features, the
   actual rule configuration keywords are different from vendors to
   vendors, making it difficult for automation.  Automation works best
   when it can leverage a common set of standards that will work across
   NSFs by multiple vendors.  Without automation, it is virtually
   impossible for clients to dynamically specify their desired rules for
   their traffic.

MGLT: My understanding is that provisionning the firewall with rules with a
YANG model is not in the scoep of i2NSF. Instead I2NSF deals with a
abstract description provided by the Client which shoudl ends in the same
rules being deployed into the firewalls of different vendors. I2NSF use
defines the high level requirements of the Customer as well as the
derivation in YANG model to configure the rules. As YANG models are vendor
independent the high level description is deployed similarly in the
multiple firewalls. Is that what the text means ?

Hares, et al.             Expires April 8, 2017                [Page 18]

Internet-Draft           I2NSF Problem/Use Case             October 2016

4.3.3.  Client-Specific Security Policy in Cloud VPNs

   Clients of service provider-operated cloud data centers need not only
   to secure Virtual Private Networks (VPNs) but also virtual security
   functions that apply the clients' security policies.  The security
   policies may govern communication within the clients' own virtual
   networks as well as communication with external networks.  For
   example, VPN service providers may need to provide firewall and other
   security services to their VPN clients.  Today, it is generally not
   possible for clients to dynamically view (let alone change) what,
   where and how security policies are implemented on their provider-
   operated clouds.  Indeed, no standards-based framework exists to
   allow clients to retrieve/manage security policies in a consistent
   manner across different providers.

 MGLT: It is not clear to me if I2NSF shoudl get these information via a
direct access to the configuration of the different NSF or if that should
be done via an audit service, which will report compliance with the
requirements.

On Mon, Oct 3, 2016 at 5:33 PM, Rafa Marin Lopez <[email-masked]> wrote:

> Dear all:
>
> I have reviewed draft-ietf-i2nsf-problem-and-use-cases and I have a few
> comments/questions (my apologies if these have been already discussed in
> the past).
>
> -----------------------
>
> Section 3.1.1
>
> -Security Functions in a DMZ. You refer to authentication and
> authorization but also AAA. Is this not redundant?
>
> -At first sight, there is no example of NSFs with flow based protection.
> That is, those that participate in the establishment of a security
> association to protect data traffic.
>
> Section 3.1.10
>
> - A general comment about this section is that the text seems to pay
> attention to routing. In our case, for example, we have an I-D to manage
> IPSec SAs based on SDNs (https://tools.ietf.org/html/
> draft-abad-i2nsf-sdn-ipsec-flow-protection-00). I guess this use case we
> present in our I-D is somehow included in the text “Conceptually, there
> must be an interface defined for routing/signaling protocols…” but I am not
> sure. Could you clarify?
>
> - A suggestion I have is to revise this paragraph:
>
> “While there are many key management methods and
>    key derivation functions (KDF), there is a lack of standard interface
>    to provision and manage keys.”
>
> There is a lack not only to provision and manage keys but also to specify
> additional information (e.g. low level policies) or to fill certain
> information to manage, in the end, a security association. Additionally, I
> am not sure about the initial sentence "While there are many key management
> methods and key derivation functions (KDF)”… what do you mean with this?
>
> Perhaps a possible modification would say:
>
>  —-> While there are many key management methods and
>    cryptographic suites (e.g. encryption algorithms, key derivation
> functions, etc…), there is a lack of standard interface
>    to provision and manage security associations.
>
>
> Regarding this paragraph:
>
> “The ability to utilize keys when routing protocols send or receive
>    messages will be enhanced by having an abstract key table maintained
>    by a security service.  Conceptually, there must be an interface
>    defined for routing/signaling protocols to make requests for
>    automated key management when it is being used, to notify the
>    protocols when keys become available in the key table.”
>
> In my opinion, it seems going into a solution space: “an abstract key
> table” and a mechanism to “pull” the keys, is this correct?. Why using this
> key table? Why using pull method so that the protocols know when the keys
> are available in the table?. Also, the text refers to routing protocols at
> the beginning. I would say that there must be an interface to configure
> security associations of any nature, no?.
>
> Section 4. In the use cases, there is no explicit text where key
> distribution is required. One may think that section 4.3.2 and, most
> probably, 4.3.3 may be related with key management (section 3.1.10). I
> mention this because our I-D focused on key management for IPSec SAs and
> VPNs is a term that may be associated to this.
>
> Section 7.
>
> When you mention AAA, are you referring to https://tools.ietf.org/html/
> rfc2904 ?
>
> ---------
>
> Best Regards.
>
>
> -------------------------------------------------------
> Rafael Marin Lopez, PhD
> Dept. Information and Communications Engineering (DIIC)
> Faculty of Computer Science-University of Murcia
> 30100 Murcia - Spain
> Telf: +34868888501 Fax: +34868884151 e-mail: [email-masked]
> -------------------------------------------------------
>
>
>
>
> _______________________________________________
> I2nsf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/i2nsf
>

---

From: "Susan Hares" <[email-masked]>
Date: Wed, 9 Nov 2016 20:46:49 -0500

-----Original Message-----
From: I2nsf [mailto:[email-masked]] On Behalf Of Rafa Marin Lopez
Sent: Monday, October 3, 2016 5:33 PM
To: [email-masked]
Cc: Rafa Marin Lopez
Subject: [I2nsf] Comments/questions about draft-ietf-i2nsf-problem-and-use-cases

Dear all:

I have reviewed draft-ietf-i2nsf-problem-and-use-cases and I have a few comments/questions (my apologies if these have been already discussed in the past).

-----------------------

Section 3.1.1

[Rafa]
-Security Functions in a DMZ. You refer to authentication and authorization but also AAA. Is this not redundant?

Sue: New text 
Security Functions in a DMZ: Examples of this
              function are firewall/ACLs, IDS/IPS, one or all of AAA services		  
              NAT, forwarding proxies, and application filtering. 
              These functions may be physically on-premise
              in a server provider's network at the DMZ spots or located in a
              "virtual" DMZ.

[Rafa #2]  
- At first sight, there is no example of NSFs with flow based protection. That is, those that participate in the establishment of a security association to protect data traffic.

[Sue #2]  Can you suggest an example NSF with flow protection.  I will be gald 

[Rafa #3 Section 3.1.10] 

- A general comment about this section is that the text seems to pay attention to routing. In our case, for example, we have an I-D to manage IPSec SAs based on SDNs (https://tools.ietf.org/html/draft-abad-i2nsf-sdn-ipsec-flow-protection-00). I guess this use case we present in our I-D is somehow included in the text “Conceptually, there must be an interface defined for routing/signaling protocols…” but I am not sure. Could you clarify?

[Sue #3]: 
I have modified the text to state: 
Conceptually, there must be an interface defined for routing/signaling protocols to make requests for automated key management when it is being used, to notify the protocols when keys become available in the key table. One potential use of such an interface is to manage IPSec security associations on SDN networks.

[Rafa #4:] 

There is a lack not only to provision and manage keys but also to specify additional information (e.g. low level policies) or to fill certain information to manage, in the end, a security association. Additionally, I am not sure about the initial sentence "While there are many key management methods and key derivation functions (KDF)”… what do you mean with this?

 —-> While there are many key management methods and
   cryptographic suites (e.g. encryption algorithms, key derivation functions, etc…), there is a lack of standard interface
   to provision and manage security associations.

[Sue #4]: I have changed the text 

[Rafa #5] 

]
In my opinion, it seems going into a solution space: “an abstract key table” and a mechanism to “pull” the keys, is this correct?. Why using this key table? Why using pull method so that the protocols know when the keys are available in the table?. Also, the text refers to routing protocols at the beginning. I would say that there must be an interface to configure security associations of any nature, no?

[Sue]: I agree.  I have removed the first sentence.  I believe this addresses your comment. 

[Rafa #6] 

Section 4. In the use cases, there is no explicit text where key distribution is required. One may think that section 4.3.2 and, most probably, 4.3.3 may be related with key management (section 3.1.10). I mention this because our I-D focused on key management for IPSec SAs and VPNs is a term that may be associated to this.

[Sue]: You are right.  I have changed the following paragraph to mention the distribution of keys. 

       Interface 1 is used for receiving security requirements from client
        and translating them into commands that NSFs can understand and
        execute. The security controller also passes back NSF security reports
        (e.g., statistics) to the client which the control has gathered from
        NSFs. Interface 2 is used for interacting with NSFs according to
        commands (e.g. enact policy and distribute key), and collecting 
		status information about NSFs.

[Rafa #7]
Section 7.

When you mention AAA, are you referring to https://tools.ietf.org/html/rfc2904 ? 

[Sue # 7]:  I've included a reference to the AAA document at that point. 

Rafa - Thanks for all the comments - Let me know if the above resolution works for you.  I'll respond to your other message, and then send you a copy of the file. 

-------------------------------------------------------
Rafael Marin Lopez, PhD
Dept. Information and Communications Engineering (DIIC) Faculty of Computer Science-University of Murcia
30100 Murcia - Spain
Telf: +34868888501 Fax: +34868884151 e-mail: [email-masked]
-------------------------------------------------------

---

From: "Susan Hares" <[email-masked]>
Date: Wed, 9 Nov 2016 23:43:25 -0500

Daniel:

I believe the 3rd revision will fix most of these problems.   I’ve included comments below.  I will send the 3rd revision out once I reach the hotel in Seoul Tonight.   Please see my comments below.   I will await your confirmation on the comments prior to adding new text into version 3. 

Sue 

From: I2nsf [mailto:[email-masked]] On Behalf Of Daniel Migault
Sent: Wednesday, November 2, 2016 6:00 AM
To: Rafa Marin Lopez
Cc: [email-masked]
Subject: Re: [I2nsf] Comments/questions about draft-ietf-i2nsf-problem-and-use-cases

Hi, 

Yours, 

Daniel

3.  Problem Space

MGLT: Maybe that woudl also be helpful to specify what I2NSF needs to define. More specifically, I2NSF should define a high level description of the interface that is implementation and vendor independent. What is not so clear to me is, in the casse of the firewall what kind of interaction are in the scope of I2NSF. From reading the gap analysis document it seems to me that provisionning and configuring the firewall with rules is not in the scope of I2NSF yet. Instead the I2NSF is interested in capabilities of the fucntions. Typically the support of IPv6 could be a capability for the firewall. 

[Sue #1]: I think I’ve done this in the new revision.  Please see if the changes address your comments. 

MGLT #2: "what it cannot view" is not clear to me. It might be helpful to be more positive and define what it can monitor. That said, what was confusing for me is whether viewing is achieved by configuring the appropriated firewall rules or because ther is a need to provide feedbacks or status on the firewall activity.  

[Sue #2]:  How about
   A challenge for monitoring is that an NSF cannot monitor what it
   cannot view within the network to determine the status of security policy, monitoring or attacks? [I’m going to wait to put this change in until you tell me it works better for you.] 

   
[ MGLT #4]  Given that statement I believe it would be helpful to understand how I2NSF is related to that challenge and how it expects to address that challenge. I also believe that such clarification could be provide for other issues.  

[Sue #4]:  The VMs with vNSF must have additional security within the hypervisor to address the movements, and the I2NSF devices must operate in an environment that knows the monitor service must make before breaking the old VM connectivity.  I know these two features must be added.  I’m not sure about more.  What do you think?  Can we come up with some text that quantifies the challenge. 

MGLT: I like the current text of this section. It is much clearer than in the previous version. ;-) and clearly state how I2NSF is expected to address this issue. 

[Sue #5]: Thank you

[MGLT #6]:  I am not sure there is a consensus on what DOTS fileters are. I believe it would hep the reader to clarify or illustrate what the profile is. I understand profile as the correlation of observations.

[Sue: #6]: The lack of definition of DOTS filters is a surprise to me.   My understanding of DOTS filters are the same type of DDoS filters we use in router’s security system.  Can you fill me in on why there are no dots filters? 

[MGLT #7]:  Would'nt it a YANG models that makes possible the definition of profiles. A profile would be in that case the speciifc instantiation of a YANG model (the set of values associated to the model). These models will be used by I2NSF to derive the actions from the Customer Interfcae which is excpected to use a more abstract description and designate the profile by a common name.        

[Sue:  #7]  Yang is just a modeling language.   A protocol carries and operates on data models.  The standard envelope is one way to define the protocol which carries the data models with enough context to be able to support the actions needed.  So.. Profiles == policy instantiated in policy data models.  Standard envelope == protocol.   I think the statement covers all of these concepts.  Do you have suggestions for alternate text? 

[MGLT #8]: It is not clear to me what "key table abstraction" is. I have little knowledge in routing protocols, but I believe this section is really routing oriented, and I hardly see any application for TLS/IPsec... other then key provisionning. Am I correct ?

[Sue #8]: Several I2NSF people have commented this text.  Please review -03.txt for the changes 

   
[MGLT #9] From the text it looks that there is a need to define a catalogue of profile. I hardly believe that everyone would converge with a single set of profiles. Instead I believe that each domain will define its own profile and need to provide them to another domain. Am I correct ? 

[Sue: #9]: I do think we will converge on basic policy filters (aka profiles).  After this point, the filters will be clustered in domain specific.   The NETCONF/RESTCONF library function would be able to catalogue such a split.  I’m not sure what text to add here.  

4.  Use Cases

[MGLT #10: Maybe it woudl be nice to position I2NSF toward this use case as in the prvious sub-sections.]

[Sue: #10] – Do you have any suggestion for specific text?  I’ve tried to weave the text toward this use case.  

   

[MGLT #12] My understanding is that provisionning the firewall with rules with a YANG model is not in the scoep of i2NSF. Instead I2NSF deals with a abstract description provided by the Client which shoudl ends in the same rules being deployed into the firewalls of different vendors. I2NSF use defines the high level requirements of the Customer as well as the derivation in YANG model to configure the rules. As YANG models are vendor independent the high level description is deployed similarly in the multiple firewalls. Is that what the text means ? 

[Sue #12]:  The scope of a protocol envelope + specific profiles (in yang modules) – do provide an interoperable vendor neutral (aka not vendor specific).  This is the purpose of the text. 

   
 [MGLT #13] It is not clear to me if I2NSF shoudl get these information via a direct access to the configuration of the different NSF or if that should be done via an audit service, which will report compliance with the requirements.   

[Sue #13] – Some people want direct access, some people want audit.  However, this is a operational design issue on the type of security.  Am I missing something?  I think I2NSF should support both options. 

Dear all:

n    These were answered earlier. 

n     

-----------------------

Section 3.1.1

-At first sight, there is no example of NSFs with flow based protection. That is, those that participate in the establishment of a security association to protect data traffic.

Section 3.1.10

In my opinion, it seems going into a solution space: “an abstract key table” and a mechanism to “pull” the keys, is this correct?. Why using this key table? Why using pull method so that the protocols know when the keys are available in the table?. Also, the text refers to routing protocols at the beginning. I would say that there must be an interface to configure security associations of any nature, no?.

Section 7.

---------

Best Regards.

-------------------------------------------------------
Rafael Marin Lopez, PhD
Dept. Information and Communications Engineering (DIIC)
Faculty of Computer Science-University of Murcia
30100 Murcia - Spain
Telf: +34868888501 <tel:%2B34868888501>  Fax: +34868884151 <tel:%2B34868884151>  e-mail: [email-masked]
-------------------------------------------------------